 /*
  * Khoros: $Id: getimage.h,v 1.2 1991/10/02 00:04:56 khoros Exp $
  */

 /*
  * $Log: getimage.h,v $
 * Revision 1.2  1991/10/02  00:04:56  khoros
 * HellPatch2
 *
  */

/*
 *----------------------------------------------------------------------
 *
 * Copyright 1991, University of New Mexico.  All rights reserved.
 * Permission to copy and modify this software and its documen-
 * tation only for internal use in your organization is hereby
 * granted, provided that this notice is retained thereon and
 * on all copies.  UNM makes no representations as to the sui-
 * tability and operability of this software for any purpose.
 * It is provided "as is" without express or implied warranty.
 * 
 * UNM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FIT-
 * NESS.  IN NO EVENT SHALL UNM BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY OTHER DAMAGES WHAT-
 * SOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER
 * IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS
 * ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PER-
 * FORMANCE OF THIS SOFTWARE.
 * 
 * No other rights, including, for example, the right to redis-
 * tribute this software and its documentation or the right to
 * prepare derivative works, are granted unless specifically
 * provided in a separate license agreement.
 *---------------------------------------------------------------------
 */

#include "unmcopyright.h"        /* Copyright 1991 by UNM */


/*>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>  <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 >>>>
 >>>>         File Name: getimage.h
 >>>>            Author: Mark Young
 >>>> Date Last Updated: Mon Sep 23 16:25:21 1991
 >>>> 
 >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>   <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<*/

#ifndef _getimage_h_
#define _getimage_h_

#include "xvinclude.h"


/* -include_includes */
#include "xvutils.h"
/* -include_includes_end */

char	**av,		/* argv and argc used by gparams */
	*program;	/* a pointer to the program name argv[0] */
int	ac;

/****************************************************************
*
*                    getimage Argument Structure
*
****************************************************************/

typedef struct _getimage  {

/*
 *  output image filename (Required outfile)
 */
char	*o     ;	/* output image filename FILENAME */
int	 o_flag;	/* output image filename FLAG */

/*
 *  extract image from screen? (Optional logical)
 */
int	 e;      	/* extract image from screen? LOGIC */
int	 e_flag;  	/* extract image from screen? FLAG */

/*
 *  get the entire screen? (Optional logical)
 */
int	 all;      	/* get the entire screen? LOGIC */
int	 all_flag;  	/* get the entire screen? FLAG */

/*
 *  name or id of window to dump (Optional string)
 */
char	*name;       	/* name or id of window to dump STRING */
int	 name_flag;   	/* name or id of window to dump FLAG */

/*
 *  output image in bitmap format? (Optional logical)
 */
int	 b;      	/* output image in bitmap format? LOGIC */
int	 b_flag;  	/* output image in bitmap format? FLAG */

/*
 *  grab the screen (WM) decoration? (Optional logical)
 */
int	 decor;      	/* grab the screen (WM) decoration? LOGIC */
int	 decor_flag;  	/* grab the screen (WM) decoration? FLAG */

/*
 *  host:display.screen (Optional string)
 */
char	*d;       	/* host:display.screen STRING */
int	 d_flag;   	/* host:display.screen FLAG */

}  getimage_struct;

getimage_struct *getimage;

/* -include_additions */
int      GETIMAGE_DONE;
/* -include_additions_end */

/* -include_macros */
/* -include_macros_end */

#endif
